routes/web.php
<?php

use Illuminate\Support\Facades\Route;

Route::get("/" , [\App\Http\Controllers\Website\ProductController::class , "index"])->name("home");
Route::get("/product/{product}" , [\App\Http\Controllers\Website\ProductController::class , "show"])->name("product.show");
Route::post("/add-to-cart/{product}" , [\App\Http\Controllers\Website\OrderController::class , "addToCart"])->name("addToCart");
Route::delete("/remove-from-cart/{product}" , [\App\Http\Controllers\Website\OrderController::class , "removeFromCart"])->name("removeFromCart");
Route::patch("/update-cart/{product}" , [\App\Http\Controllers\Website\OrderController::class , "updateCart"])->name("updateCart");


Route::get("/cart" , [\App\Http\Controllers\Website\OrderController::class , "cartShow"])->name("cartShow");
Route::post("/cart/address" , [\App\Http\Controllers\Website\OrderController::class , "addAddress"])->name("addAddress");
Route::get("/invoice" , [\App\Http\Controllers\Website\OrderController::class , "invoice"])->name("invoice");
Route::post("/order/store" , [\App\Http\Controllers\Website\OrderController::class , "store"])->name("orderStore")->middleware("auth");
Route::match(['get' , 'post'] , '/pay-result' , [\App\Http\Controllers\Website\OrderController::class , "payResult"])->name("payResult");


Route::middleware("guest")
    ->prefix("auth")
    ->group(function (){
        Route::get("/login" , [\App\Http\Controllers\AuthController::class , "loginView"])->name("login");
        Route::post("/login" , [\App\Http\Controllers\AuthController::class , "loginSubmit"])->name("loginSubmit");
        Route::get("/register" , [\App\Http\Controllers\AuthController::class , "registerView"])->name("register");
        Route::post("/register" , [\App\Http\Controllers\AuthController::class , "registerSubmit"])->name("registerSubmit");
    });

Route::middleware("dashboard")
    ->prefix("dashboard")
    ->name("dashboard.")
    ->group(function(){
        Route::get("/" , [\App\Http\Controllers\Dashboard\DashboardController::class , "index"])->name("index");
        Route::resource("/product" , \App\Http\Controllers\Dashboard\ProductController::class);
    });

Route::get("/logout" , [\App\Http\Controllers\AuthController::class , "logout"])->name("logout");

app/Models/Product.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Model;

class Product extends Model
{
    protected $fillable = [
        'title',
        'body',
        'price',
        'image',
    ];

    public function getImageShowAttribute()
    {
        return url()->asset("storage/" . $this->image);
    }
    public function getHrefUrlAttribute()
    {
        return route("product.show" , ['product' => $this->id]);
    }
    public function getPriceShowAttribute()
    {
        return number_format($this->price);
    }
    public function getLeadAttribute()
    {
        return \Illuminate\Support\Str::limit(strip_tags($this->body), 150, ' ...');
    }
}

app/Http/Controllers/Dashboard/DashboardController.php
<?php

namespace App\Http\Controllers\Dashboard;

use App\Http\Controllers\Controller;
use Illuminate\Http\Request;

class DashboardController extends Controller
{
    public function index()
    {
        return redirect(route("dashboard.product.index"));
    }
}

app/Http/Controllers/Dashboard/ProductController.php
<?php

namespace App\Http\Controllers\Dashboard;

use App\Models\Product;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Validator;

class ProductController extends DashboardController
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $products = Product::latest()->simplePaginate(2);
        return view("Dashboard.Product.index" , compact(
            'products'
        ));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        return view("Dashboard.Product.create")  ;
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        $validator = Validator::make($request->all(), [
            'title' => 'required|min:2|max:255',
            'body' => 'nullable',
            'price' => 'required|numeric',
            "image" => 'required|mimes:jpg,png|max:2048',
        ]);

        if ($validator->fails()) {
            return redirect()
                ->back()
                ->withErrors($validator)
                ->withInput();
        }


        $imageName = time() . "_" . rand(1000 , 9999) . "." . $request->image->extension();

        $imageFilePatch = $request->image->storeAs("images" , $imageName , 'public');


        Product::create([
            "title" => $request->title ,
            "body" => $request->body ,
            "price" => $request->price ,
            "image" => $imageFilePatch ,
        ]);

        return redirect(route("dashboard.product.index"));

    }

    /**
     * Display the specified resource.
     *
     * @param  \App\Models\Product  $product
     * @return \Illuminate\Http\Response
     */
    public function show(Product $product)
    {
        abort(404);
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  \App\Models\Product  $product
     * @return \Illuminate\Http\Response
     */
    public function edit(Product $product)
    {
        return view("Dashboard.Product.edit" , compact(
            'product'
        ))  ;
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \App\Models\Product  $product
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, Product $product)
    {

        $validator = Validator::make($request->all(), [
            'title' => 'required|min:2|max:255',
            'body' => 'nullable',
            'price' => 'required|numeric',
            "image" => 'nullable|mimes:jpg,png|max:2048',
        ]);

        if ($validator->fails()) {
            return redirect()
                ->back()
                ->withErrors($validator)
                ->withInput();
        }

        if ($request->image)
        {
            $imageName = time() . "_" . rand(1000 , 9999) . "." . $request->image->extension();
            $imageFilePatch = $request->image->storeAs("images" , $imageName , 'public');
        }
        else
        {
            $imageFilePatch = $product->image;
        }



        $product->update([
            "title" => $request->title ,
            "body" => $request->body ,
            "price" => $request->price ,
            "image" => $imageFilePatch ,
        ]);

        return redirect(route("dashboard.product.index"));
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  \App\Models\Product  $product
     * @return \Illuminate\Http\Response
     */
    public function destroy(Product $product)
    {
        $product->delete();
        return redirect(route("dashboard.product.index"));
    }
}

app/Http/Controllers/Website/ProductController.php
<?php

namespace App\Http\Controllers\Website;

use App\Models\Cart;
use App\Models\Product;
use Illuminate\Http\Request;

class ProductController extends WebsiteController
{
    public function index(Request  $request)
    {
        $products = Product::latest()->simplePaginate(9);
        $oldCart = $request->session()->has("cart") ? $request->session()->get("cart") : null;
        $cart = new Cart($oldCart);
        return view("Website.Product.index" , compact(
            "products" ,
            'cart'
        ));
    }

    public function show(Product $product, Request  $request)
    {
        $oldCart = $request->session()->has("cart") ? $request->session()->get("cart") : null;
        $cart = new Cart($oldCart);
        return view("Website.Product.show" , compact(
            'product' ,
            'cart'
        ));
    }

}

resources/views/Dashboard/Product/create.blade.php
@extends("Dashboard.app")
@section("title" , "Product Index")

@section("main")
    <div class="container mt-5">
        <div class="row justify-content-center">
            <div class="col-lg-6">
                <div class="card-custom-1">
                    <form action="{{ route("dashboard.product.store") }}" method="post" enctype="multipart/form-data">
                        @csrf
                        <div class="mb-3">
                            <label for="title" class="form-label">Title</label>
                            <input type="text" name="title" id="title" class="form-control @error('title') is-invalid @enderror" placeholder="Title" value="{{ old("title") }}" aria-describedby="invalid-title">
                            <div id="invalid-title" class="invalid-feedback">
                                {{ $errors->first("title") }}
                            </div>
                        </div>
                        <div class="mb-3">
                            <label for="price" class="form-label">Price</label>
                            <input type="number" name="price" id="price" class="form-control @error('price') is-invalid @enderror" placeholder="Price" value="{{ old("price") }}" aria-describedby="invalid-price">
                            <div id="invalid-price" class="invalid-feedback">
                                {{ $errors->first("price") }}
                            </div>
                        </div>
                        <div class="mb-3">
                            <label for="body" class="form-label">body</label>
                            <textarea name="body" id="body" class="form-control @error('body') is-invalid @enderror" aria-describedby="invalid-body">{{ old("body") }}</textarea>
                            <div id="invalid-body" class="invalid-feedback">
                                {{ $errors->first("body") }}
                            </div>
                        </div>
                        <div class="mb-3">
                            <input type="file" name="image" id="image" class="form-control @error('image') is-invalid @enderror"   aria-describedby="invalid-image">
                            <div id="invalid-image" class="invalid-feedback">
                                {{ $errors->first("image") }}
                            </div>
                        </div>
                        <div class=" ">
                            <button type="submit" class="btn btn-success">Send</button>
                        </div>
                    </form>
                </div>
            </div>
        </div>
    </div>
@endsection

resources/views/Dashboard/Product/edit.blade.php
@extends("Dashboard.app")
@section("title" , "Product Index")

@section("main")
    <div class="container mt-5">
        <div class="row justify-content-center">
            <div class="col-lg-6">
                <div class="card-custom-1">
                    <form action="{{ route("dashboard.product.update" , ['product' => $product->id]) }}" method="post" enctype="multipart/form-data">
                        @csrf
                        @method("PATCH")
                        <div class="mb-3">
                            <label for="title" class="form-label">Title</label>
                            <input type="text" name="title" id="title" class="form-control @error('title') is-invalid @enderror" placeholder="Title" value="{{ old("title" , $product->title) }}" aria-describedby="invalid-title">
                            <div id="invalid-title" class="invalid-feedback">
                                {{ $errors->first("title") }}
                            </div>
                        </div>
                        <div class="mb-3">
                            <label for="price" class="form-label">Price</label>
                            <input type="number" name="price" id="price" class="form-control @error('price') is-invalid @enderror" placeholder="Price" value="{{ old("price", $product->price) }}" aria-describedby="invalid-price">
                            <div id="invalid-price" class="invalid-feedback">
                                {{ $errors->first("price") }}
                            </div>
                        </div>
                        <div class="mb-3">
                            <label for="body" class="form-label">body</label>
                            <textarea name="body" id="body" class="form-control @error('body') is-invalid @enderror" aria-describedby="invalid-body">{{ old("body", $product->body) }}</textarea>
                            <div id="invalid-body" class="invalid-feedback">
                                {{ $errors->first("body") }}
                            </div>
                        </div>
                        <div class="mb-3">
                            <input type="file" name="image" id="image" class="form-control @error('image') is-invalid @enderror"   aria-describedby="invalid-image">
                            <div id="invalid-image" class="invalid-feedback">
                                {{ $errors->first("image") }}
                            </div>
                        </div>
                        <div class=" ">
                            <button type="submit" class="btn btn-success">Send</button>
                        </div>
                    </form>
                </div>
            </div>
        </div>
    </div>
@endsection

resources/views/Dashboard/Product/index.blade.php
@extends("Dashboard.app")
@section("title" , "Product Index")

@section("main")

    <div class="container mt-5">
        <div class="row justify-content-center">
            <div class="col-lg-6">
                <div class="card-custom-1">
                    <div class="table-responsive">
                        <table class="table caption-top">
                            <caption>
                                Product Index
                                <a href="{{ route("dashboard.product.create") }}" class="d-inline-block ml-2">
                                    Create
                                </a>
                            </caption>
                            <thead>
                                <tr>
                                    <th scope="col">#</th>
                                    <th scope="col">title</th>
                                    <th scope="col">price</th>
                                    <th scope="col">image</th>
                                </tr>
                            </thead>
                            <tbody>
                                @foreach($products as $product)
                                    <tr>
                                        <th scope="row">
                                            <a class="btn btn-warning" href="{{ route("dashboard.product.edit", ['product' => $product->id]) }}">
                                                Edit
                                            </a>
                                            <form class="d-inline-block ml-2" method="post" action="{{ route("dashboard.product.destroy" , ['product' => $product->id]) }}">
                                                @csrf
                                                @method("DELETE")
                                                <button type="submit" class="btn btn-danger">Delete</button>
                                            </form>
                                        </th>
                                        <td>{{ $product->title }}</td>
                                        <td>{{ number_format($product->price) }}</td>
                                        <td>
                                            <img src="{{ $product->imageShow }}" class="table-img">
                                        </td>
                                    </tr>
                                @endforeach
                            </tbody>
                        </table>

                    </div>
                    <div class="row justify-content-center mt-2">
                        <div class="col-auto">
                            {{ $products->links() }}
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
@endsection